package com.followlast;

import java.util.ArrayList;

public class BinaryTree<T extends Comparable<T>> {
    StackNode treeStack;
    Queue queue = new Queue(10000);
    int nposition = 0;
    int current_index = 0;
    int allength = 0;
    double infinite = Double.POSITIVE_INFINITY;
    double subexp1 = 0;
    double subexp2 = 0;

    public BinaryTree() {
        super();
    }

    int layer = 0;

    public int calcuLayer(Node<Integer> root) {
        if (root != null) {
            //root.setLayer(layer);
            ArrayList<Node> childs = root.dirChild(root);
            if (!childs.isEmpty()) {
                layer = root.getLayer() + 1;
                for (int i = 0; i < childs.size(); i++) {
                    childs.get(i).setLayer(layer);
                }
                for (int i = 0; i < childs.size(); i++) {
                    calcuLayer(childs.get(i));
                }
            }
        }
        return layer;
    }

    public Node<Integer> buildTree(String outString) {
        int stackSize = outString.length();
        treeStack = new StackNode(stackSize);
        char ch = ' ';
        int num;
        for (int i = 0; i < outString.length(); i++) {
            ch = outString.charAt(i);
            if (ch == '[') {                          //识别上标
                ch = outString.charAt(++i);
                if (Util.isDigitA(ch)) {
                    num = 0;
                    while (Util.isDigitA(ch)) {
                        num = (int) (num * Math.pow(10, 1)) + Integer.parseInt(String.valueOf(ch));
                        ch = outString.charAt(++i);
                    }
                    Node<Integer> newNode = new Node<Integer>();
                    newNode.setKey(num);
                    newNode.setIndicator(true);
                    Node<Integer> leftNode = new Node<Integer>();
                    Integer leftChar = treeStack.peek().getKey();
                    if (treeStack.peek().isAlphabet()) { //建树or从栈中读取
                        leftNode = createNode(leftChar);
                        leftNode.setAlphabet(true);
                        treeStack.pop();
                    } else {
                        leftNode = treeStack.pop();
                    }
                    newNode.setLeftNode(leftNode);
                    //System.out.println(newNode.getLeftNode().getKey());
//					if(i==(outString.length())) {
                    // 我改的
                    if (i == outString.length() - 1) {
                        return newNode;
                    } else {
                        treeStack.push(newNode);
                    }
                }
            } else if (ch == '*' || ch == '+' || ch == '?') {
                Node<Integer> newNode = new Node<Integer>();
                newNode.setKey(ch);
                Node<Integer> leftNode = new Node<Integer>();
                Integer leftChar = treeStack.peek().getKey();
                if (treeStack.peek().isAlphabet()) {
                    leftNode = createNode(leftChar);
                    leftNode.setAlphabet(true);
                    treeStack.pop();
                } else {
                    leftNode = treeStack.pop();
                }
                newNode.setLeftNode(leftNode);
//				if(i==(outString.length())) {
                // 我改的
                if (i == outString.length() - 1) {
                    return newNode;
                } else {
                    treeStack.push(newNode);
                }
            } else if (Util.isDigitA(ch)) {
                ++current_index;
                num = 0;
                allength = 0;
                while (Util.isDigitA(ch)) {
                    num = (int) (num * Math.pow(10, 1)) + Integer.parseInt(String.valueOf(ch));
                    ++allength;
                    if (allength < InTopost.alphabet_list[current_index - 1]) {
                        ch = outString.charAt(++i);
                    } else {
                        ++i;
                        break;
                    }
                }
                i--;
                Node<Integer> newNode = new Node<Integer>();
                newNode.setKey(num);
                newNode.setAlphabet(true);
                treeStack.push(newNode);
            } else {
                Node<Integer> newNode = new Node<Integer>();
                newNode.setKey(ch);
                Node<Integer> rightNode = new Node<Integer>();
                Node<Integer> leftNode = new Node<Integer>();

                Integer rightChar = treeStack.peek().getKey();
                if (treeStack.peek().isAlphabet()) {
                    rightNode = createNode(rightChar);
                    rightNode.setAlphabet(true);
                    treeStack.pop();
                } else {
                    rightNode = treeStack.pop();
                }
                Integer leftChar = treeStack.peek().getKey();
                if (treeStack.peek().isAlphabet()) {
                    leftNode = createNode(leftChar);
                    leftNode.setAlphabet(true);
                    treeStack.pop();
                } else {
                    leftNode = treeStack.pop();
                }
                newNode.setLeftNode(leftNode);
                newNode.setRightNode(rightNode);

                if (i == (outString.length() - 1)) {
                    return newNode;
                } else {
                    treeStack.push(newNode);
                }
            }
        }
        return treeStack.pop();
    }

    public void markMultiful(Node<Integer> node) {
        int uper = 0;
        if (node != null) {
            if (node.getKey() == 43 || node.getKey() == 42) {
                node.setMultiful(true);
            } else if (node.isIndicator()) {
                uper = Expression.indicator[2 * Integer.parseInt(String.valueOf(node.getKey())) + 1];
                if (uper > 1) {
                    node.setMultiful(true);
                }
                // 新增 修复((a+)+)?的判断错误
                markMultiful(node.getLeftNode());
            } else {
                markMultiful(node.getLeftNode());
                markMultiful(node.getRightNode());
            }
        }
    }

    public void inOrder(Node<Integer> node) {
        if (node != null) {
            inOrder(node.getLeftNode());
            inOrder(node.getRightNode());
        }
    }

    public void travelNum() {

        Node<Integer> temp1 = new Node<Integer>();
        while (!queue.isEmpty()) {

            temp1 = queue.remove();
            int nkey = temp1.getKey();
            if (temp1.isAlphabet()) {
                //System.out.print(nkey);
                //System.out.print(temp1.getNumber());
            }
        }
    }

    public Queue countSym(Node<Integer> node) {
        if (node != null) {
            countSym(node.getLeftNode());
            countSym(node.getRightNode());
            if (node.isAlphabet()) {
                queue.insert(node);
            }
        }
        return queue;
    }

    public int leafNode(Node<Integer> node) {
        int leaf1, leaf2;
        if (node == null)
            return 0;
        else if (node.getLeftNode() == null && node.getRightNode() == null)
            return 1;
        else {
            leaf1 = leafNode(node.getLeftNode());
            leaf2 = leafNode(node.getRightNode());
            return (leaf1 + leaf2);
        }
    }

	/*	public void ininOrder(Node node)
	{
		if(node!=null)
		{  
			if(!(node.getLeftNode()==null)&&!(node.getRightNode()==null)){
				 ininOrder(node.getLeftNode());
					System.out.println(node.getKey()+" ");
				 ininOrder(node.getRightNode());
			}

		}�������ͬһ��β������ı���
	}*/

    public void levelOrder(Node<Integer> node) {
        if (node == null) {
            return;
        }
        ArrayList<Node<Integer>> list = new ArrayList<Node<Integer>>();
        list.add(node);
        int cur = 0;
        int last = 1;
        while (cur < list.size()) {
            last = list.size();
            while (cur < last) {
                if ((list.get(cur).getRightNode()) != null) {
                    list.add(list.get(cur).getRightNode());
                }
                if (list.get(cur).getLeftNode() != null) {
                    list.add(list.get(cur).getLeftNode());
                }
                cur++;
            }
        }
    }

    public void operateNode(Node<Integer> node) {
        if (node != null) {
            inOrder(node.getLeftNode());
            inOrder(node.getRightNode());
        }

    }

    //�ַ������
    public Node<Integer> createNode(Integer integer) {
        Node<Integer> node = new Node<Integer>();
        if (Expression.index.get(integer) == null) {
            node.setKey(integer);

            node.setNumber(1);
            Expression.index.put(integer, 1);
        } else {
            int number = Expression.index.get(integer);

            number++;
            node.setKey(integer);
            node.setNumber(number);
            Expression.index.put(integer, number);
        }
        return node;
    }

    public void markNullable(Node<Integer> node) {
        int low = 0;
        int index;
        if (node == null) {
            return;
        }
        if (node.isIndicator()) {
            index = node.getKey();
            low = Expression.indicator[2 * index];
            markNullable(node.getLeftNode());
            if (low == 0) {
                node.setNullable(true);
            } else {
                node.setNullable(node.getLeftNode().isNullable());
            }
        } else if ((!node.isAlphabet()) && (!node.isIndicator())) {//& ,
            if (node.getKey() == 38 || node.getKey() == 44) {
                markNullable(node.getLeftNode());
                markNullable(node.getRightNode());
                node.setNullable(node.getLeftNode().isNullable() && node.getRightNode().isNullable());
            } else if (node.getKey() == 124) {//|
                markNullable(node.getLeftNode());
                markNullable(node.getRightNode());
                node.setNullable(node.getLeftNode().isNullable() || node.getRightNode().isNullable());
            } else if (node.getKey() == 43) {
                node.setNullable(false);
                markNullable(node.getLeftNode());
            } else if (node.getKey() == 63 || node.getKey() == 42) {
                node.setNullable(true);
                markNullable(node.getLeftNode());
            }
        } else {
            node.setNullable(false);
        }
    }

    public double markFlexible1(Node<Integer> node, int n) {
        int bounds = n;
        int low;
        int uper;
        if (node != null) {
            if ((!node.isAlphabet()) && (!node.isIndicator())) {
                if (node.getKey() == 124) {
                    return Math.max(markFlexible(node.getLeftNode(), bounds), markFlexible(node.getRightNode(), bounds));
                } else if (node.getKey() == 44 || node.getKey() == 38) {
                    if (node.getRightNode().isNullable()) {
                        subexp1 = markFlexible(node.getLeftNode(), bounds);
                    } else {
                        subexp1 = markFlexible(node.getLeftNode(), 1);
                    }
                    if (node.getLeftNode().isNullable()) {
                        subexp2 = markFlexible(node.getRightNode(), bounds);
                    } else {
                        subexp2 = markFlexible(node.getRightNode(), 1);
                    }
                    if (node.getLeftNode().isNullable()) {
                        if (node.getRightNode().isNullable()) {
                            return infinite;
                        } else {
                            return subexp2;
                        }
                    } else if (node.getRightNode().isNullable()) {
                        return subexp1;
                    } else {
                        return 1;
                    }
                } else if (node.getKey() == 43 || node.getKey() == 63 || node.getKey() == 42) {
                    if (node.getKey() == 63) {
                        markFlexible(node.getLeftNode(), bounds);
                        return infinite;
                    } else {
                        node.setFlexible(true);
                        markFlexible(node.getLeftNode(), bounds);
                        return infinite;
                    }
                }
            } else if (node.isIndicator()) {
                low = Expression.indicator[2 * node.getKey()];
                uper = Expression.indicator[2 * node.getKey() + 1];
                if (low == 0 && uper == 1) {
                    markFlexible(node.getLeftNode(), bounds);

                    return infinite;
                }
                //bounds=bounds*uper;	// 和markFlexible的区别在于这一行注释掉了
                subexp1 = markFlexible(node.getLeftNode(), bounds);
                if (low < uper || subexp1 >= ((double) bounds / (bounds - 1))) {
                    node.setFlexible(true);
                }
                return subexp1 * ((double) uper / low);
            } else {
                return 1;
            }
        }
        return 1;
    }

    public double markFlexible(Node<Integer> node, int n) {

        int bounds = n;
        int low;
        int uper;
        if (node != null) {
            if ((!node.isAlphabet()) && (!node.isIndicator())) {
                if (node.getKey() == 124) {
                    return Math.max(markFlexible(node.getLeftNode(), bounds), markFlexible(node.getRightNode(), bounds));
                } else if (node.getKey() == 44 || node.getKey() == 38) {
                    if (node.getRightNode().isNullable()) {
                        subexp1 = markFlexible(node.getLeftNode(), bounds);
                    } else {
                        subexp1 = markFlexible(node.getLeftNode(), 1);
                    }
                    if (node.getLeftNode().isNullable()) {
                        subexp2 = markFlexible(node.getRightNode(), bounds);
                    } else {
                        subexp2 = markFlexible(node.getRightNode(), 1);
                    }
                    if (node.getLeftNode().isNullable()) {
                        if (node.getRightNode().isNullable()) {
                            return infinite;
                        } else {
                            return subexp2;
                        }
                    } else if (node.getRightNode().isNullable()) {
                        return subexp1;
                    } else {
                        return 1;
                    }
                } else if (node.getKey() == 43 || node.getKey() == 63 || node.getKey() == 42) {
                    if (node.getKey() == 63) {
                        markFlexible(node.getLeftNode(), bounds);
                        return infinite;
                    } else {
                        node.setFlexible(true);
                        markFlexible(node.getLeftNode(), bounds);
                        return infinite;
                    }

                }
            } else if (node.isIndicator()) {
                low = Expression.indicator[2 * node.getKey()];
                uper = Expression.indicator[2 * node.getKey() + 1];
                if (low == 0 && uper == 1) {
                    markFlexible(node.getLeftNode(), bounds);

                    return infinite;
                }
                bounds = bounds * uper;
                subexp1 = markFlexible(node.getLeftNode(), bounds);
                if (low < uper || subexp1 >= ((double) bounds / (bounds - 1))) {
                    node.setFlexible(true);
                }
                return subexp1 * ((double) uper / low);
            } else {
                return 1;
            }
        }
        return 1;
    }

}
