package com.followlast;

import java.util.HashMap;

public class Expression {
    public static Node<Integer> root = null;
    public static HashMap<Integer, Integer> index = new HashMap<Integer, Integer>();
    protected static int layer;
    public static int[] indicator;

    public static Record expression(String input) {
    	input = preprocessRegex(input);

        Record record = new Record();
        float excTime;
        String regularString;
        String outString;
        String xxx;
        input = Util.preprocess(input.replaceAll(" ", ""));

        Udtool2.result = Udtool2.result + "------------------------------------------" + "\n";
        Udtool2.result = Udtool2.result + "--The simplified expression is " + input + ".\n";
        index = new HashMap<Integer, Integer>();
        char[] inputChar = input.toCharArray();
        indicator = new int[inputChar.length];
        BinaryTree<Character> currentTree = new BinaryTree<Character>();
        regularString = dIndicator(inputChar);

        InTopost tranString = new InTopost(regularString);
        outString = tranString.transform();
        xxx = printString(outString);
        //Udtool2.result = Udtool2.result+ "For expression "+String.valueOf(inputChar)+", the Postfix Expression is: "+xxx+"\n";

        root = currentTree.buildTree(outString);
        layer = currentTree.calcuLayer(root);
        currentTree.markNullable(root);
        currentTree.markFlexible(root, 1);
        currentTree.inOrder(root);
        currentTree.markFlexible1(root, 1);
        currentTree.inOrder(root);
        Conditions ce = new Conditions();
        long startTime = System.nanoTime();
        if (!ce.seekCharacter(root)) {
            Udtool2.result = Udtool2.result + "    !!! The expression is not weakly deterministic." + "\n";
            return record;
        }
        long endTime = System.nanoTime();
        excTime = endTime - startTime;
        record.setTime(excTime);
        record.setDeterministic(true);
        Udtool2.result = Udtool2.result + "    !The expression is weakly deterministic." + "\n";
        return record;
    }

    private static String printString(String outString) {
        String pString = "";
        char[] aa = outString.toCharArray();
        for (int i = 0; i < aa.length; i++) {
            pString = pString + (aa[i]) + " ";
            if (aa[i] == '[') {
                pString += (indicator[((int) aa[++i]) - 48]);
                pString += ",";
                pString += (indicator[((int) aa[i]) - 48 + 1]);
            }
        }
        return pString;
    }

    private static String dIndicator(char[] inputChar) {
        StringBuilder result = new StringBuilder();
        int index = 0;
        int numLow = 0;
        int numUp = 0;
        for (int i = 0; i < inputChar.length; i++) {
            if (inputChar[i] == '[') {
                numLow = 0;
                numUp = 0;
                i++;
                index++;
                while (inputChar[i] != ',') {
                    numLow = (int) (numLow * Math.pow(10, 1)) + (Integer.parseInt(String.valueOf(inputChar[i])));
                    i++;
                    if (inputChar[i] == ']') {
                        numUp = numLow;
                        indicator[2 * (index - 1)] = numLow;
                        indicator[2 * (index - 1) + 1] = numUp;
                        result.append('[');
                        result.append(index - 1);
                        result.append(']');

                        break;
                    }
                }
                if (inputChar[i] == ',') {
                    i++;
                    while (inputChar[i] != ']') {
                        numUp = (int) (numUp * Math.pow(10, 1)) + (Integer.parseInt(String.valueOf(inputChar[i])));
                        i++;
                    }
                    result.append('[');
                    result.append(index - 1);
                    result.append(']');
                    indicator[2 * (index - 1)] = numLow;
                    indicator[2 * (index - 1) + 1] = numUp;
                }
            }
            if (inputChar[i] != ']') {

                result.append(inputChar[i]);
            }
        }
        return result.toString();
    }

	// 预处理正则 使之适配mou的只能支持[m,n](n>1)的counting
	public static String preprocessRegex(String regex) {
		regex = regex.replace(".", ",");
        regex = regex.replace(",]",",2147483647]");
        regex = regex.replace(",*]", ",2147483647]");
		regex = regex.replace("?", "[0,1]"); // 这里?没有重写为[0,1]是因为mou对[0,1]支持错误
		regex = regex.replace("+", "[1,2147483647]");
		regex = regex.replace("*", "[0,2147483647]");
		regex = regex.replace("{", "[").replace("}", "]");
		return regex;
	}

	// 反向预处理
	public static String unpreprocessRegex(String regex) {
		regex = regex.replace("[1,2147483647]", "+");
		regex = regex.replace("[0,2147483647]", "*");
		return regex;
	}
}
